/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Borland-compatible creattmp function
*
****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <direct.h>
#include <string.h>
#include <dos.h>
#include <errno.h>

#ifndef COUNTRY
_WCRTLINK extern int _creat( const char *path, int attrib );
#endif

_WCRTLINK int creattemp( char *filename, int attrib )
{
    char tmppath[ _MAX_PATH ];
    
    if( filename[ strlen( filename ) - 1 ] != '\\') {/* Path must end in \ */
        errno = ENOENT;
        return -1;
    }
    
    sprintf( tmppath, "%s%s", filename, _mktemp( "XXXXXX" ) );
    while( access( tmppath, 0 ) == 0 )
        sprintf( tmppath, "%s%s", filename, _mktemp( "XXXXXX" ) );
    strcpy( filename, tmppath );

    return( ( tmppath[0] == '\0' ) ? -1 : _creat( tmppath, attrib ) );
}

